<script lang="ts">
import Vue from 'vue';
import { AosAnimationsMixin } from '../mixins';
import SlpNavigationHOC from '../components/navigation/navigation-hoc.vue';
import NavBanner from '~/components/navigation/nav-banner.vue';
import SlpFooterHOC from '~/components/navigation/footer-hoc.vue';
import { generateLayoutMeta } from '~/common/meta';
import { MetaInfo } from 'vue-meta/types/vue-meta';

export default Vue.extend({
  components: {
    SlpFooterHOC,
    SlpNavigationHOC,
    NavBanner,
  },
  mixins: [AosAnimationsMixin],
  data() {
    return {
      footer: {},
      contentfulEntryUrl: '',
      showBanner: true,
    };
  },
  head(): MetaInfo {
    return generateLayoutMeta(this.$route.path, this.$i18n.locale);
  },
  beforeMount() {
    this.validateIndexFiles();
  },
  methods: {
    shouldShowBanner() {
      if (
        this.$route.path === '/gitlab-duo/' ||
        this.$route.path === '/seventeen/' ||
        this.$route.path === '/gitlab-duo' ||
        this.$route.path === '/seventeen' ||
        this.$route.path === '/pricing/'
      ) {
        this.showBanner = false;
      } else {
        this.showBanner = true;
      }
    },
    validateIndexFiles() {
      if (this.$route.path.endsWith('index.html')) {
        const queryParams = this.$route.query;
        const oldPath = this.$route.path.replace(/(\W*index\.html\W*)/g, '');
        this.$router.replace({
          path: `${oldPath}/`,
          query: queryParams,
        });
      }
    },
  },
});
</script>

<template>
  <div>
    <!-- <HomeTopBanner /> -->
    <NavBanner v-if="showBanner" :current-locale="$i18n.locale" />
    <SlpNavigationHOC />
    <section ref="localizedContainer">
      <Nuxt role="main" />
    </section>
    <SlpFooterHOC :contentful-entry-id="contentfulEntryUrl" />
  </div>
</template>
